Subject: Re: jgit and ignore

From: "Shawn O. Pearce" <[email-masked]>
Date: Sun, 1 Mar 2009 09:47:29 -0800

"Ferry Huberts (Pelagic)" <[email-masked]> wrote:
> > IMHO, we should honor ignores in EGit as:
> > 
> >   per-directory .gitignore
> >   per-repostiory GIT_DIR/info/exclude
> > 
> >   per-repository core.excludesfile (yes, really, it can be per
> >   repository, which overrides ~/.gitconfig setting of same)
> 
> wow. override? really?

Yes.  I'd have to go back and read the git-core code again, but in
general a config setting of foo.bar in GIT_DIR/config overrides a
foo.bar setting in ~/.gitconfig, *unless* you use the --all flag.

Most of the C code parses as though the last value seen is the
only value set, and GIT_DIR/config is parsed after ~/.gitconfig,
hence it overrides.
 
> >   Eclipse global team ignore patterns
> 
> so, should these then override, supplement, or something else?
> the per-repo files (.gitignore's and info/exclude supplement eachother.

They all supplement each other.  You union every entry in that list
into a single override set and then evaluate against that.  That list
changes with each directory, due to the per-directory .gitignore
possibly changing, but otherwise its fixed for any given repository.
 
-- 
Shawn.